Bug 18582 - [3.4 Regression] Internal compiler error with arrays of type V2DF
Summary: [3.4 Regression] Internal compiler error with arrays of type V2DF
Status: RESOLVED FIXED
Alias: None
Product: gcc
Classification: Unclassified
Component: target (show other bugs)
Version: 3.4.3
: P2 normal
Target Milestone: 3.4.5
Assignee: rsandifo@gcc.gnu.org
URL:
Keywords: ice-on-valid-code
Depends on:
Blocks:
 
Reported: 2004-11-20 20:09 UTC by Steffen Boerm
Modified: 2005-08-03 14:18 UTC (History)
1 user (show)

See Also:
Host: i686-pc-linux-gnu
Target: i686-pc-linux-gnu
Build: i686-pc-linux-gnu
Known to work:
Known to fail:
Last reconfirmed: 2005-08-02 15:46:10


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Steffen Boerm 2004-11-20 20:09:27 UTC
Using

  gcc -c ice.c

with the following file "ice.c"

  typedef double v2df __attribute__((mode(V2DF)));
  void
  sse_interpolate_kernel()
  {
    double x2[2];
    v2df xs[2];
    xs[0] = __builtin_ia32_loadupd(x2);
  }

leads to the following internal compiler error:

  ice.c: In function `sse_interpolate_kernel':
  ice.c:11: internal compiler error: in instantiate_virtual_regs_lossage, at
    function.c:3756
  Please submit a full bug report,

The error seems to disappear if I replace the array xs by simple variables or if
I use "-O".
Comment 1 Andrew Pinski 2004-11-20 20:21:56 UTC
: Search converges between 2003-01-27-trunk (#173) and 2003-02-03-trunk (#174).
: Search converges between 2003-01-28-3.3 (#19) and 2003-02-04-3.3 (#20).


Fixed on the mainline by the merge of the tree-ssa:
: Search converges between 2004-05-11-trunk (#454) and 2004-05-14-trunk (#455).
Fixed on the tree-ssa branch:
: Search converges between 2003-08-15-ssa (#58) and 2003-08-16-ssa (#59).

(note this does not make sense as usually the things are fixed by the tree-ssa when optimizing).
Comment 2 rsandifo@gcc.gnu.org 2005-08-02 15:46:10 UTC
This is a bug in the i386 builtin expansion code.  Testing a fix.
Comment 3 CVS Commits 2005-08-03 14:05:39 UTC
Subject: Bug 18582

CVSROOT:	/cvs/gcc
Module name:	gcc
Changes by:	rsandifo@gcc.gnu.org	2005-08-03 14:05:02

Modified files:
	gcc/testsuite  : ChangeLog 
Added files:
	gcc/testsuite/gcc.dg/torture: pr18582-1.c 

Log message:
	PR target/18582
	* testsuite/gcc.dg/torture/pr18582-1.c: New test.

Patches:
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/ChangeLog.diff?cvsroot=gcc&r1=1.5871&r2=1.5872
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/gcc.dg/torture/pr18582-1.c.diff?cvsroot=gcc&r1=NONE&r2=1.1

Comment 4 CVS Commits 2005-08-03 14:06:15 UTC
Subject: Bug 18582

CVSROOT:	/cvs/gcc
Module name:	gcc
Branch: 	gcc-4_0-branch
Changes by:	rsandifo@gcc.gnu.org	2005-08-03 14:06:05

Modified files:
	gcc/testsuite  : ChangeLog 
Added files:
	gcc/testsuite/gcc.dg/torture: pr18582-1.c 

Log message:
	PR target/18582
	* testsuite/gcc.dg/torture/pr18582-1.c: New test.

Patches:
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/ChangeLog.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=1.5084.2.315&r2=1.5084.2.316
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/gcc.dg/torture/pr18582-1.c.diff?cvsroot=gcc&only_with_tag=gcc-4_0-branch&r1=NONE&r2=1.1.2.1

Comment 6 rsandifo@gcc.gnu.org 2005-08-03 14:18:19 UTC
Patch applied to 3.4.  Relevant parts of testcase also
applied to HEAD and 4.0.